## kbibtex 0.9.90

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7.2)

if(POLICY CMP0048)
    cmake_policy(SET CMP0048 NEW)
endif(POLICY CMP0048)

project(
    kbibtex
    VERSION 0.9.90
    LANGUAGES CXX
)

set(CMAKE_CXX_STANDARD 11)
set(QT_MIN_VERSION 5.9.0)
# Somewhat arbitrary chosen version number ...
set(KF5_MIN_VERSION 5.51)
find_package(ECM ${KF5_MIN_VERSION} REQUIRED NO_MODULE)

set(
    CMAKE_MODULE_PATH
    ${ECM_MODULE_PATH}
    ${ECM_KDE_MODULE_DIR}
    ${CMAKE_MODULE_PATH}
)

set(KDE_INSTALL_DIRS_NO_DEPRECATED TRUE)
include(KDEInstallDirs)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings)
include(ECMGenerateHeaders)
include(ECMInstallIcons)
include(ECMSetupVersion)
include(ECMAddAppIcon)
include(GenerateExportHeader)
include(ECMQtDeclareLoggingCategory)

ecm_setup_version(
    PROJECT
    VARIABLE_PREFIX KBIBTEX
    SOVERSION ${KBIBTEX_VERSION_MAJOR}
    VERSION_HEADER "${CMAKE_BINARY_DIR}/kbibtex-version.h"
    PACKAGE_VERSION_FILE "${CMAKE_BINARY_DIR}/KBibTeXConfigVersion.cmake"
)

install(
    FILES ${CMAKE_BINARY_DIR}/kbibtex-version.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/KBibTeX
    # FIXME is "Devel" standard?
    COMPONENT Devel
)


if("${KBIBTEX_VERSION_PATCH}" STREQUAL "")
    # Patch level is not set for version numbers like "0.9",
    # so set the patch level manually to 0
    set(KBIBTEX_VERSION_PATCH 0)
endif()

if((${KBIBTEX_VERSION_PATCH} GREATER 50) OR (${KBIBTEX_VERSION_PATCH} EQUAL 50))
    # If the version number indicates a pre-release version such as
    # '0.7.90', i.e. a beta version for the major release 0.8,
    # increment release version from 0.7 to 0.8
    math(EXPR KBIBTEX_RELEASE_VERSION_MINOR "${KBIBTEX_VERSION_MINOR} + 1")
    set(
        KBIBTEX_RELEASE_VERSION ${KBIBTEX_VERSION_MAJOR}.${KBIBTEX_RELEASE_VERSION_MINOR}
    )
else()
    set(
        KBIBTEX_RELEASE_VERSION ${KBIBTEX_VERSION_MAJOR}.${KBIBTEX_VERSION_MINOR}
    )
endif()

option(
    UNITY_BUILD
    "Compile multiple C++ files in one big, merged file (\"Unity build\")\nSee also http://t-fischer.dreamwidth.org/3054.html"
)
if(UNITY_BUILD)
    message(STATUS "Unity build enabled")
else(UNITY_BUILD)
    message(STATUS "Unity build disabled (default), use option UNITY_BUILD to enable it")
endif(UNITY_BUILD)

find_package(
    Qt5 ${QT_MIN_VERSION}
    CONFIG
    COMPONENTS
    Core
    Widgets
    Network
    XmlPatterns
    Concurrent
    NetworkAuth
    OPTIONAL_COMPONENTS
    WebEngineWidgets
    WebKitWidgets
    Test
)
add_definitions(-DHAVE_QTWIDGETS)
if(Qt5WebEngineWidgets_FOUND)
    # Once CMake 3.12.x is minimum requirement, use 'add_compile_definitions'
    add_definitions(
        -DHAVE_WEBENGINEWIDGETS
    )
endif()

find_package(
    KF5 ${KF5_MIN_VERSION}
    MODULE
    REQUIRED
    I18n
    XmlGui
    KIO
    IconThemes
    Parts
    CoreAddons
    Service
    Wallet
    Crash
    TextEditor
    OPTIONAL_COMPONENTS
    DocTools
)
add_definitions(-DHAVE_KF5)

find_package(
    Poppler
    MODULE
    REQUIRED
    Qt5
)

find_package(
    ICU
    MODULE
    OPTIONAL_COMPONENTS
    uc i18n
)
if(ICU_FOUND)
    add_definitions(-DHAVE_ICU)
endif()

option(
    BUILD_TESTING
    "Build automated and interactive tests"
    OFF
)
if (MSVC)
    MESSAGE( STATUS "Disabling building tests when using Microsoft Visual Studio C++ compiler" )
    # Note to any developer: Try to enable building tests and see which issues you may encounter.
    # Examples may include: (1) char* texts which exceed the size limit supported by MSVC which
    # is about 2^16 bytes and (2) characters in strings written in \uXXXX notation not supported
    # in 1252 encoding as assumed by MSVC for C++ source files.
    set(BUILD_TESTING OFF)
endif()
if(NOT BUILD_TESTING AND Qt5Test_FOUND)
    message(STATUS
        "Testing is disabled, but can be enabled as the Qt5::Test library is available"
    )
endif()
if(BUILD_TESTING AND NOT Qt5Test_FOUND)
    message(STATUS
        "Disabling building tests as Qt5::Test library is not available"
    )
    set(BUILD_TESTING OFF)
endif()

if(BUILD_TESTING)
    if (WRITE_RAWDATAFILE)
        add_definitions(-DWRITE_RAWDATAFILE)
    endif(WRITE_RAWDATAFILE)

    set(
        TESTSET_DIRECTORY ""
        CACHE PATH
        "Directory where the local checkout of Git repository 'kbibtex-testset' is located"
    )
endif()

if(TESTSET_DIRECTORY AND ( NOT EXISTS "${TESTSET_DIRECTORY}/bib/minix.bib" OR NOT EXISTS "${TESTSET_DIRECTORY}/bib/backslash.bib" ))
    message("Variable TESTSET_DIRECTORY is set to '${TESTSET_DIRECTORY}' but various BibTeX files were not found. Unsetting TESTSET_DIRECTORY.")
    unset(TESTSET_DIRECTORY)
    unset(TESTSET_DIRECTORY CACHE)
endif()


add_subdirectory(
    config
)
add_subdirectory(
    src
)
add_subdirectory(
    xslt
)
add_subdirectory(
    mime
)
if(KF5DocTools_FOUND)
    add_subdirectory(doc)
endif()
# macro_optional_add_subdirectory(
#     po
# )

if (ECM_VERSION VERSION_GREATER_EQUAL "5.59.0")
    install(FILES kbibtex.categories DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR})
else()
    install(FILES kbibtex.categories DESTINATION ${KDE_INSTALL_CONFDIR})
endif()

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

find_package(KF5I18n CONFIG REQUIRED)
ki18n_install(po)

  find_package(KF5DocTools CONFIG)
  if(KF5DocTools_FOUND)
    kdoctools_install(po)
  endif()

=== doc/CMakeLists.txt ===
# Create and install documentation (handbook)

kdoctools_create_handbook(
    index.docbook
    INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en
    SUBDIR kbibtex
)

# Create and install documentation (man page)

kdoctools_create_manpage(
    man-kbibtex.1.docbook 1
    INSTALL_DESTINATION ${KDE_INSTALL_MANDIR}
)

=== src/io/CMakeLists.txt ===
set(
    kbibtexio_SRCS
    encoder.cpp
    encoderlatex.cpp
    encoderxml.cpp
    fileexporterbibtex2html.cpp
    fileexporterbibtex.cpp
    fileexporterbibutils.cpp
    fileexporterbibtexoutput.cpp
    fileexporter.cpp
    fileexporterpdf.cpp
    fileexporterps.cpp
    fileexporterris.cpp
    fileexporterrtf.cpp
    fileexportertoolchain.cpp
    fileexporterxml.cpp
    fileexporterxslt.cpp
    fileimporterbibtex.cpp
    fileimporterbibutils.cpp
    fileimporter.cpp
    fileimporterpdf.cpp
    fileimporterris.cpp
    fileinfo.cpp
    textencoder.cpp
    bibutils.cpp
    xsltransform.cpp
)

ecm_qt_declare_logging_category(kbibtexio_SRCS
    HEADER logging_io.h
    IDENTIFIER LOG_KBIBTEX_IO
    CATEGORY_NAME kbibtex.io
)

if(UNITY_BUILD)
    enable_unity_build(kbibtexio kbibtexio_SRCS)
endif(UNITY_BUILD)

add_library(kbibtexio
    SHARED
    ${kbibtexio_SRCS}
)
generate_export_header(kbibtexio)
add_library(KBibTeX::IO ALIAS kbibtexio)

set_target_properties(kbibtexio
    PROPERTIES
    EXPORT_NAME "kbibtexio"
    VERSION ${KBIBTEX_RELEASE_VERSION}
    SOVERSION ${KBIBTEX_SOVERSION}
)

target_include_directories(kbibtexio
    INTERFACE
        $<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR}/KBibTeX/io>
)

target_link_libraries(kbibtexio
    PUBLIC
        Qt5::Core
        KBibTeX::Data
        KBibTeX::Global
    PRIVATE
        Poppler::Qt5
        Qt5::Concurrent
        Qt5::XmlPatterns
        KF5::I18n
        KBibTeX::Config
)

if(ICU_FOUND)
    target_link_libraries(kbibtexio
        PRIVATE
            ICU::uc
            ICU::i18n
    )
endif()

install(
    TARGETS kbibtexio
    EXPORT kbibtexio-targets
    LIBRARY NAMELINK_SKIP
    ${KDE_INSTALL_TARGETS_DEFAULT_ARGS}
)

set_target_properties(kbibtexio PROPERTIES
    EXPORT_NAME "IO"
)

ecm_generate_headers(kbibtexio_HEADERS
    HEADER_NAMES
        BibUtils
        Encoder
        EncoderLaTeX
        EncoderXML
        FileExporter
        FileExporterBibTeX
        FileExporterBibTeX2HTML
        FileExporterBibTeXOutput
        FileExporterBibUtils
        FileExporterPDF
        FileExporterPS
        FileExporterRIS
        FileExporterRTF
        FileExporterToolchain
        FileExporterXML
        FileExporterXSLT
        FileImporter
        FileImporterBibTeX
        FileImporterBibUtils
        FileImporterPDF
        FileImporterRIS
        FileInfo
        TextEncoder
        XSLTransform
    REQUIRED_HEADERS kbibtexio_HEADERS
)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/kbibtexio_export.h
    ${kbibtexio_HEADERS}
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/KBibTeX/io
    COMPONENT Devel
)

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXIO-configVersion.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY ExactVersion
)

configure_package_config_file(${CMAKE_CURRENT_LIST_DIR}/cmake/KBibTeXIO-config.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXIO-config.cmake
    INSTALL_DESTINATION ${KDE_INSTALL_LIBDIR}/cmake/KBibTeX
)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXIO-config.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXIO-configVersion.cmake
    DESTINATION ${KDE_INSTALL_LIBDIR}/cmake/KBibTeX
)

=== src/networking/CMakeLists.txt ===
set(
    kbibtexnetworking_SRCS
    onlinesearch/onlinesearchabstract.cpp
    onlinesearch/onlinesearchbibsonomy.cpp
    onlinesearch/onlinesearcharxiv.cpp
    onlinesearch/onlinesearchsciencedirect.cpp
    onlinesearch/onlinesearchgooglescholar.cpp
    onlinesearch/onlinesearchieeexplore.cpp
    onlinesearch/onlinesearchpubmed.cpp
    onlinesearch/onlinesearchacmportal.cpp
    onlinesearch/onlinesearchspringerlink.cpp
    onlinesearch/onlinesearchmathscinet.cpp
    onlinesearch/onlinesearchmrlookup.cpp
    onlinesearch/onlinesearchinspirehep.cpp
    onlinesearch/onlinesearchcernds.cpp
    onlinesearch/onlinesearchingentaconnect.cpp
    onlinesearch/onlinesearchsimplebibtexdownload.cpp
    onlinesearch/onlinesearchgeneral.cpp
    onlinesearch/onlinesearchsoanasaads.cpp
    onlinesearch/onlinesearchideasrepec.cpp
    onlinesearch/onlinesearchdoi.cpp
    onlinesearch/onlinesearchbiorxiv.cpp
    onlinesearch/onlinesearchsemanticscholar.cpp
    zotero/api.cpp
    zotero/collectionmodel.cpp
    zotero/collection.cpp
    zotero/items.cpp
    zotero/groups.cpp
    zotero/oauthwizard.cpp
    zotero/tags.cpp
    zotero/tagmodel.cpp
    associatedfiles.cpp
    findpdf.cpp
    internalnetworkaccessmanager.cpp
    urlchecker.cpp
)

if(Qt5WebEngineWidgets_FOUND)
    # See also below for a similar if-clause
    message(STATUS "Using QtWebEngine parse JStor pages")
    # Once CMake 3.12.x is minimum requirement, use 'add_compile_definitions'
    set(
        kbibtexnetworking_SRCS
        ${kbibtexnetworking_SRCS}
        onlinesearch/onlinesearchjstor.cpp
    )
endif()

ecm_qt_declare_logging_category(kbibtexnetworking_SRCS
    HEADER logging_networking.h
    IDENTIFIER LOG_KBIBTEX_NETWORKING
    CATEGORY_NAME kbibtex.networking
)

if(UNITY_BUILD)
    enable_unity_build(kbibtexnetworking kbibtexnetworking_SRCS)
endif(UNITY_BUILD)

add_library(kbibtexnetworking
    SHARED
    ${kbibtexnetworking_SRCS}
)
generate_export_header(kbibtexnetworking)
add_library(KBibTeX::Networking ALIAS kbibtexnetworking)

set_target_properties(kbibtexnetworking
    PROPERTIES
    EXPORT_NAME "kbibtexnetworking"
    VERSION ${KBIBTEX_RELEASE_VERSION}
    SOVERSION ${KBIBTEX_SOVERSION}
)

target_include_directories(kbibtexnetworking
    INTERFACE
        $<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR}/KBibTeX/networking>
)

target_link_libraries(kbibtexnetworking
    PUBLIC
        Qt5::Core
        Qt5::Network
        Qt5::Widgets
        KBibTeX::Data
    PRIVATE
        Poppler::Qt5
        Qt5::DBus
        Qt5::NetworkAuth
        KF5::ConfigCore
        KF5::WidgetsAddons
        KF5::I18n
        KF5::KIOCore
        KF5::KIOFileWidgets
        KBibTeX::Config
        KBibTeX::Global
        KBibTeX::IO
)

if(Qt5WebEngineWidgets_FOUND)
    # See also above for a similar if-clause
    target_link_libraries(kbibtexnetworking
        PRIVATE
            Qt5::WebEngineWidgets
    )
endif()

install(
    TARGETS kbibtexnetworking
    EXPORT kbibtexnetworking-targets
    LIBRARY NAMELINK_SKIP
    ${KDE_INSTALL_TARGETS_DEFAULT_ARGS}
)

set_target_properties(kbibtexnetworking PROPERTIES
    EXPORT_NAME "Networking"
)

ecm_generate_headers(kbibtexnetworking_HEADERS
    HEADER_NAMES
        AssociatedFiles
        FindPDF
        InternalNetworkAccessManager
        UrlChecker
        onlinesearch/OnlineSearchAbstract
        onlinesearch/OnlineSearchGeneral
        onlinesearch/OnlineSearchAcmPortal
        onlinesearch/OnlineSearchArXiv
        onlinesearch/OnlineSearchBibsonomy
        onlinesearch/OnlineSearchBioRxiv
        onlinesearch/OnlineSearchCERNDS
        onlinesearch/OnlineSearchDOI
        onlinesearch/OnlineSearchGoogleScholar
        onlinesearch/OnlineSearchIDEASRePEc
        onlinesearch/OnlineSearchIEEEXplore
        onlinesearch/OnlineSearchIngentaConnect
        onlinesearch/OnlineSearchInspireHep
        onlinesearch/OnlineSearchJStor
        onlinesearch/OnlineSearchMathSciNet
        onlinesearch/OnlineSearchMRLookup
        onlinesearch/OnlineSearchPubMed
        onlinesearch/OnlineSearchScienceDirect
        onlinesearch/OnlineSearchSemanticScholar
        onlinesearch/OnlineSearchSimpleBibTeXDownload
        onlinesearch/OnlineSearchSOANASAADS
        onlinesearch/OnlineSearchSpringerLink
        zotero/API
        zotero/Collection
        zotero/CollectionModel
        zotero/Groups
        zotero/Items
        zotero/OAuthWizard
        zotero/TagModel
        zotero/Tags
    REQUIRED_HEADERS kbibtexnetworking_HEADERS
)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/kbibtexnetworking_export.h
    ${kbibtexnetworking_HEADERS}
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/KBibTeX/networking
    COMPONENT Devel
)

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXNetworking-configVersion.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY ExactVersion
)

configure_package_config_file(${CMAKE_CURRENT_LIST_DIR}/cmake/KBibTeXNetworking-config.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXNetworking-config.cmake
    INSTALL_DESTINATION ${KDE_INSTALL_LIBDIR}/cmake/KBibTeX
)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXNetworking-config.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXNetworking-configVersion.cmake
    DESTINATION ${KDE_INSTALL_LIBDIR}/cmake/KBibTeX
)

=== src/parts/CMakeLists.txt ===
set(
    kbibtexpart_SRCS
    part.cpp
    partfactory.cpp
)

ecm_qt_declare_logging_category(kbibtexpart_SRCS
    HEADER logging_part.h
    IDENTIFIER LOG_KBIBTEX_PART
    CATEGORY_NAME kbibtex.part
)

if(UNITY_BUILD)
    enable_unity_build(kbibtexpart kbibtexpart_SRCS)
endif(UNITY_BUILD)

add_library(kbibtexpart
    MODULE
    ${kbibtexpart_SRCS}
)

add_dependencies(kbibtexpart
    generate-kbibtex-git-info
)

target_include_directories(kbibtexpart
    PRIVATE
        ${CMAKE_BINARY_DIR}
)

target_link_libraries(kbibtexpart
    PRIVATE
        KF5::Parts
        KF5::CoreAddons
        KF5::I18n
        KBibTeX::GUI
        KBibTeX::IO
        KBibTeX::Networking
        KBibTeX::Processing
)

install(
    TARGETS
    kbibtexpart
    DESTINATION
    ${KDE_INSTALL_PLUGINDIR}
)

kcoreaddons_desktop_to_json(kbibtexpart kbibtexpart.desktop SERVICE_TYPES kpart.desktop)
install(
    FILES
    kbibtexpart.desktop
    DESTINATION
    ${KDE_INSTALL_KSERVICES5DIR}
)
install(
    FILES
    kbibtexpartui.rc
    DESTINATION
    ${KDE_INSTALL_KXMLGUI5DIR}/kbibtexpart
)

=== src/test/CMakeLists.txt ===
include(AddFileDependencies)
include(ECMMarkAsTest)

configure_file(test-config.h.in test-config.h @ONLY)

set(
    kbibtextest_SRCS
    main.cpp
    kbibtextest.cpp
)

ecm_qt_declare_logging_category(kbibtextest_SRCS
    HEADER logging_test.h
    IDENTIFIER LOG_KBIBTEX_TEST
    CATEGORY_NAME kbibtex.test
)


set(
    kbibtexnetworkingtest_SRCS
    kbibtexnetworkingtest.cpp
)

set(
    kbibtexiotest_SRCS
    kbibtexiotest.cpp
)

ecm_qt_declare_logging_category(kbibtexiotest_SRCS
    HEADER logging_test.h
    IDENTIFIER LOG_KBIBTEX_TEST
    CATEGORY_NAME kbibtex.test
)

set(
    kbibtexdatatest_SRCS
    kbibtexdatatest.cpp
)

if(UNITY_BUILD AND NOT WIN32) # FIXME: Unity build of programs breaks on Windows
    enable_unity_build(kbibtextest kbibtextest_SRCS)
    enable_unity_build(kbibtexnetworkingtest kbibtexnetworkingtest_SRCS)
    enable_unity_build(kbibtexiotest kbibtexiotest_SRCS)
    enable_unity_build(kbibtexdatatest kbibtexdatatest_SRCS)
endif(UNITY_BUILD AND NOT WIN32)

add_executable(
    kbibtextest
    ${kbibtextest_SRCS}
)

add_dependencies(kbibtextest
    generate-kbibtex-git-info
)

add_executable(
    kbibtexnetworkingtest
    ${kbibtexnetworkingtest_SRCS}
)

add_dependencies(kbibtexnetworkingtest
    generate-kbibtex-git-info
)

add_executable(
    kbibtexiotest
    ${kbibtexiotest_SRCS}
)

add_dependencies(kbibtexiotest
    generate-kbibtex-git-info
)

add_executable(
    kbibtexdatatest
    ${kbibtexdatatest_SRCS}
)

add_dependencies(kbibtexdatatest
    generate-kbibtex-git-info
)

target_link_libraries(kbibtextest
    Qt5::Core
    KF5::KIOCore
    KF5::I18n
    KBibTeX::Config
    KBibTeX::Data
    KBibTeX::IO
    KBibTeX::Processing
    KBibTeX::GUI
    KBibTeX::Networking
)

target_include_directories(kbibtextest
    PRIVATE
        ${CMAKE_BINARY_DIR}
)

target_link_libraries(kbibtexnetworkingtest
    PRIVATE
        Qt5::Test
        KBibTeX::Networking
)

target_include_directories(kbibtexnetworkingtest
    PRIVATE
        ${CMAKE_BINARY_DIR}
)

target_link_libraries(kbibtexiotest
    PRIVATE
        Qt5::Test
        KF5::I18n
        KF5::ConfigCore
        KBibTeX::IO
)

target_include_directories(kbibtexiotest
    PRIVATE
        ${CMAKE_BINARY_DIR}
)

target_link_libraries(kbibtexdatatest
    PRIVATE
        Qt5::Test
        KBibTeX::Data
)

target_include_directories(kbibtexdatatest
    PRIVATE
        ${CMAKE_BINARY_DIR}
)

ecm_mark_as_test(
    kbibtexnetworkingtest
    kbibtexiotest
    kbibtexdatatest
)

add_test(
    NAME
    kbibtexnetworkingtest
    COMMAND
    kbibtexnetworkingtest
)

add_test(
    NAME
    kbibtexiotest
    COMMAND
    kbibtexiotest
)

add_test(
    NAME
    kbibtexdatatest
    COMMAND
    kbibtexdatatest
)

if(TESTSET_DIRECTORY)
    set(
        kbibtexfilestest_SRCS
        kbibtexfilestest.cpp
        kbibtexfilestest-rawdata.h
    )
    ecm_qt_declare_logging_category(kbibtexfilestest_SRCS
        HEADER logging_test.h
        IDENTIFIER LOG_KBIBTEX_TEST
        CATEGORY_NAME kbibtex.test
    )
    if(UNITY_BUILD AND NOT WIN32) # FIXME: Unity build of programs breaks on Windows
        enable_unity_build(kbibtexfilestest kbibtexfilestest_SRCS)
    endif()
    add_executable(
        kbibtexfilestest
        ${kbibtexfilestest_SRCS}
    )
    add_dependencies(kbibtexfilestest
        generate-kbibtex-git-info
    )
    target_link_libraries(kbibtexfilestest
        PRIVATE
            Qt5::Test
            KBibTeX::Data
            KBibTeX::IO
    )
    target_include_directories(kbibtexfilestest
        PRIVATE
            ${CMAKE_BINARY_DIR}
    )
    ecm_mark_as_test(
        kbibtexfilestest
    )
    add_test(
        NAME
        kbibtexfilestest
        COMMAND
        kbibtexfilestest
    )
endif()

=== debian/changelog ===
kbibtex (0.9.90-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add upstream fixes for crashes with newer Qt versions.
    (Closes: #1018922)

 -- Adrian Bunk <bunk@debian.org>  Tue, 07 Feb 2023 18:22:51 +0200

kbibtex (0.9.90-1) unstable; urgency=medium

  * New upstream release:
    - since we use the release tarballs now, the translations are available
      (Closes: #911523)
  * Add myself to Uploaders.
  * Update the patches:
    - upstream_cmake-use-the-right-variable-for-man-page-install-de.patch:
      drop, backported from upstream
  * Update install files.

 -- Pino Toscano <pino@debian.org>  Tue, 12 Jan 2021 01:04:01 +0100

kbibtex (0.9.81-2) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * Follow a hint of Rik Mills and rather Build-Depend: qtwebengine5-dev

  [ Pino Toscano ]
  * Switch watch file to track the official tarballs, rather than random tags
    on the GitHub mirror.
  * Drop our own debian/missing-sources/COPYING-CMAKE-SCRIPTS and the reference
    to it in debian/copyright, as this file is no more referenced by upstream
    sources.
  * Stop rebuilding the application icon: upstream ships already proper icons,
    and more sized can be asked to be shipped in case they are needed
    - drop the imagemagick, inkscape, and librsvg2-bin build dependencies,
      no more needed now
  * Drop all the manual handling of build flags, as everything is properly
    handled already since debhelper compatibility 9.
  * Drop all the development files, i.e. cmake config files and headers, in
    addition to .so symlinks.
  * Install the missing files.
  * Unregister the old /etc/xdg/kbibtexrc conffile.
  * Stop passing --list-missing to dh_missing, as everything is installed now.
  * Drop the 'run' autopkgtest:
    - never passed (at least in the last 3 years)
    - too fragile to maintain
    - it does not test anything much of use
  * Reference the actual upstream Git repository in debian/upstream/metadata.
  * Use the kf5 dh addon, so common bits for KF5-based applications (e.g. not
    compressing the DocBook documentation) are applied.
  * Remove the explicit as-needed linking, as it is done by binutils now.
  * Drop the wrong Multi-Arch: foreign field from kbibtex, as it is hardly a
    "tool" for other architectures.
  * Update and simplify the lintian overrides.
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.7.2
    - bump the Qt packages to 5.9.0
    - bump the KF packages to 5.51.0
    - explicitly add gettext, libicu-dev, pkg-config, and shared-mime-info
    - remove the unused/unneeded qtbase5-dev-tools, libkf5itemviews-dev,
      libkf5completion-dev, libqca-qt5-2-dev, and libxslt1-dev
  * The unit tests still fail, so disable their build by passing
    -DBUILD_TESTING=OFF to cmake.
  * Do not export DH_VERBOSE=1, as there is no need to get a really verbose
    build log by default.
  * Restrict the qtwebengine5-dev build dependency to the architectures where
    it is present, using libqt5webkit5-dev on any other architecture.
  * Backport upstream commit 40d3149cfaf5c3b1f3b1110617d291eb332d76f3 to fix
    the installation of the man page; patch
    upstream_cmake-use-the-right-variable-for-man-page-install-de.patch
    - update debian/kbibtex-data.install
    - drop debian/kbibtex-data.manpages, no more needed now

 -- Pino Toscano <pino@debian.org>  Tue, 15 Dec 2020 18:22:08 +0100

kbibtex (0.9.81-1) unstable; urgency=medium

  [ Bastien Roucariès ]
  * New upstream version
  * Bug fix: "build-depends on deprecated Frameworks -dev packages",
    thanks to Pino Toscano (Closes: #885388).
  * Bug fix: "Allow reference to be imported from worldcat", thanks to
    Bastien ROUCARIES (Closes: #507987).
  * Bug fix: "Include international reference libraries as search
    engines", thanks to Axel Stammler (Closes: #776750).
  * Bug fix: "FTBFS with clang instead of gcc", thanks to Alexander
    (Closes: #753270).

  [ Andreas Tille ]
  * d/watch: drop unneeded uupdate since it spoils routine-update
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target (routine-
    update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * No tab in license text (routine-update)
  * Update renamed lintian tag names in lintian overrides.
  * Set upstream metadata fields: Repository, Repository-Browse.
  * Build-Depends: libkf5texteditor-dev, libqt5webenginewidgets5,
    libqt5networkauth5-dev
  * There is no /etc dir any more
  * Fix installation of manpage

 -- Andreas Tille <tille@debian.org>  Thu, 26 Nov 2020 10:36:16 +0100

=== debian/control ===
Source: kbibtex
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Bastien Roucariès <rouca@debian.org>,
           Pino Toscano <pino@debian.org>,
Section: kde
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake (>= 3.7.2~),
               extra-cmake-modules (>= 5.51.0~),
               gettext,
               qtbase5-dev (>= 5.9.0~),
               libicu-dev,
               libkf5doctools-dev (>= 5.51.0~),
               libkf5i18n-dev (>= 5.51.0~),
               libkf5xmlgui-dev (>= 5.51.0~),
               libkf5kio-dev (>= 5.51.0~),
               libkf5iconthemes-dev (>= 5.51.0~),
               libkf5parts-dev (>= 5.51.0~),
               libkf5coreaddons-dev (>= 5.51.0~),
               libkf5service-dev (>= 5.51.0~),
               libkf5wallet-dev (>= 5.51.0~),
               libkf5crash-dev (>= 5.51.0~),
               libkf5texteditor-dev (>= 5.51.0~),
               libqt5xmlpatterns5-dev (>= 5.9.0~),
               qtwebengine5-dev (>= 5.9.0~) [amd64 arm64 armhf i386 mipsel],
               libqt5webkit5-dev (>= 5.9.0~) [!amd64 !arm64 !armhf !i386 !mipsel],
               libqt5networkauth5-dev (>= 5.9.0~),
               libpoppler-qt5-dev,
               pkg-config,
               pkg-kde-tools,
               shared-mime-info,
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/science-team/kbibtex
Vcs-Git: https://salsa.debian.org/science-team/kbibtex.git
Homepage: https://userbase.kde.org/KBibTeX
Rules-Requires-Root: no

Package: kbibtex
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         kbibtex-data (= ${source:Version})
Recommends: texlive-bibtex-extra,
            biber
Suggests: texlive-latex-base,
          bibtex2html,
          latex2rtf
Description: BibTeX editor for KDE
 An application to manage bibliography databases in the BibTeX format. KBibTeX
 can be used as a standalone program, but can also be embedded into other KDE
 applications (e.g. as bibliography editor into Kile).
 .
 KBibTeX can query online resources (e.g. Google scholar) via customizable
 search URLs. It is also able to import complete datasets from NCBI Pubmed.
 It also supports tagging references with keywords and manages references to
 local files.
 .
 BibTeX files can be exported into HTML, XML, PDF, PS and RTF format using a
 number of citation styles.

Package: kbibtex-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: texlive-bibtex-extra
Breaks: kbibtex (<< 0.6+git7fdc0cd97c093f-1~)
Replaces: kbibtex (<< 0.6+git7fdc0cd97c093f-1~)
Description: BibTeX editor for KDE -- common data
 An application to manage bibliography databases in the BibTeX format. KBibTeX
 can be used as a standalone program, but can also be embedded into other KDE
 applications (e.g. as bibliography editor into Kile).
 .
 KBibTeX can query online resources (e.g. Google scholar) via customizable
 search URLs. It is also able to import complete datasets from NCBI Pubmed.
 It also supports tagging references with keywords and manages references to
 local files.
 .
 BibTeX files can be exported into HTML, XML, PDF, PS and RTF format using a
 number of citation styles.
 .
 This package include common data needed by kbibtex binaries.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export QT_SELECT:=5

# one ring to rule them all ...
%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DBUILD_TESTING=OFF

override_dh_auto_install:
	dh_auto_install
	# remove all the development files
	find debian/tmp -name '*.so' -type l -delete
	rm -rf debian/tmp/usr/lib/*/cmake/
	rm -rf debian/tmp/usr/include/

override_dh_auto_test:
	# the unit tests fail ATM
	:

## kbibtex 0.10.0

=== config/CMakeLists.txt ===
install(
    FILES
    bibtex.kbstyle
    biblatex.kbstyle
    jabref_journalabbrevlist.txt
    DESTINATION
    ${KDE_INSTALL_DATADIR}/kbibtex
)

=== mime/CMakeLists.txt ===
find_package(
    SharedMimeInfo
)

########### install files ###############
install(
    FILES
    bibliography.xml
    DESTINATION
    ${KDE_INSTALL_MIMEDIR}
)
update_xdg_mimetypes(
    ${KDE_INSTALL_MIMEDIR}
)

=== xslt/CMakeLists.txt ===
install(
    FILES
    fancy.xsl
    standard.xsl
    abstractonly.xsl
    arxiv2bibtex.xsl
    pubmed2bibtex.xsl
    pam2bibtex.xsl
    isbndb2bibtex.xsl
    ieeexploreapiv1-to-bibtex.xsl
    wikipedia-cite.xsl
    worldcatdc2bibtex.xsl
    DESTINATION
    ${KDE_INSTALL_DATADIR}/kbibtex
)

=== src/config/CMakeLists.txt ===
set(
    kbibtexconfig_SRCS
    notificationhub.cpp
    bibtexentries.cpp
    bibtexfields.cpp
    preferences.cpp
)

ecm_qt_declare_logging_category(kbibtexconfig_SRCS
    HEADER logging_config.h
    IDENTIFIER LOG_KBIBTEX_CONFIG
    CATEGORY_NAME kbibtex.config
)

if(UNITY_BUILD)
    enable_unity_build(kbibtexconfig kbibtexconfig_SRCS)
endif(UNITY_BUILD)

add_library(kbibtexconfig
    SHARED
    ${kbibtexconfig_SRCS}
)

generate_export_header(kbibtexconfig)
add_library(KBibTeX::Config ALIAS kbibtexconfig)

set_target_properties(kbibtexconfig
    PROPERTIES
    EXPORT_NAME "kbibtexconfig"
    VERSION ${KBIBTEX_RELEASE_VERSION}
    SOVERSION ${KBIBTEX_SOVERSION}
)

target_include_directories(kbibtexconfig
    INTERFACE
        $<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR}/KBibTeX/config>
)

target_link_libraries(kbibtexconfig
    PUBLIC
        Qt5::Core
        Qt5::Gui
        KBibTeX::Global
    PRIVATE
        KF5::ConfigCore
        KF5::I18n
)

install(
    TARGETS kbibtexconfig
    EXPORT kbibtexconfig-targets
    LIBRARY NAMELINK_SKIP
    ${KDE_INSTALL_TARGETS_DEFAULT_ARGS}
)

set_target_properties(kbibtexconfig PROPERTIES
    EXPORT_NAME "Config"
)

ecm_generate_headers(kbibtexconfig_HEADERS
    HEADER_NAMES
        BibTeXEntries
        BibTeXFields
        NotificationHub
        Preferences
    REQUIRED_HEADERS kbibtexconfig_HEADERS
)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/kbibtexconfig_export.h
    ${kbibtexconfig_HEADERS}
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/KBibTeX/config
    COMPONENT Devel
)

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXConfig-configVersion.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY ExactVersion
)

configure_package_config_file(${CMAKE_CURRENT_LIST_DIR}/cmake/KBibTeXConfig-config.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXConfig-config.cmake
    INSTALL_DESTINATION ${KDE_INSTALL_LIBDIR}/cmake/KBibTeX
)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXConfig-config.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXConfig-configVersion.cmake
    DESTINATION ${KDE_INSTALL_LIBDIR}/cmake/KBibTeX
)

=== src/global/CMakeLists.txt ===
set(
    kbibtexglobal_SRCS
    kbibtex.cpp
)

ecm_qt_declare_logging_category(kbibtexglobal_SRCS
    HEADER logging_global.h
    IDENTIFIER LOG_KBIBTEX_GLOBAL
    CATEGORY_NAME kbibtex.global
)

if(UNITY_BUILD)
    enable_unity_build(kbibtexglobal kbibtexglobal_SRCS)
endif(UNITY_BUILD)

add_library(kbibtexglobal
    SHARED
    ${kbibtexglobal_SRCS}
)
generate_export_header(kbibtexglobal)
add_library(KBibTeX::Global ALIAS kbibtexglobal)

set_target_properties(
    kbibtexglobal
    PROPERTIES
    EXPORT_NAME "kbibtexglobal"
    VERSION ${KBIBTEX_RELEASE_VERSION}
    SOVERSION ${KBIBTEX_SOVERSION}
)

target_include_directories(kbibtexglobal
    INTERFACE
        $<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR}/KBibTeX/global>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/global>
)

target_link_libraries(kbibtexglobal
    PUBLIC
        Qt5::Core
    PRIVATE
        KF5::ConfigCore
        KF5::I18n
)

install(
    TARGETS kbibtexglobal
    EXPORT kbibtexglobal-targets
    ${KDE_INSTALL_TARGETS_DEFAULT_ARGS}
)

set_target_properties(kbibtexglobal PROPERTIES
    EXPORT_NAME "Global"
)

ecm_generate_headers(kbibtexglobal_HEADERS
    HEADER_NAMES
        KBibTeX
    REQUIRED_HEADERS kbibtexglobal_HEADERS
)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/kbibtexglobal_export.h
    ${kbibtexglobal_HEADERS}
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/KBibTeX/global
    COMPONENT Devel
)

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXGlobal-configVersion.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY ExactVersion
)

configure_package_config_file(${CMAKE_CURRENT_LIST_DIR}/cmake/KBibTeXGlobal-config.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXGlobal-config.cmake
    INSTALL_DESTINATION ${KDE_INSTALL_LIBDIR}/cmake/KBibTeX
)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXGlobal-config.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXGlobal-configVersion.cmake
    DESTINATION ${KDE_INSTALL_LIBDIR}/cmake/KBibTeX
)

=== src/gui/CMakeLists.txt ===
set(
    kbibtexgui_SRCS
    element/associatedfilesui.cpp
    element/elementeditor.cpp
    element/elementwidgets.cpp
    element/findpdfui.cpp
    field/colorlabelwidget.cpp
    field/fieldinput.cpp
    field/fieldlineedit.cpp
    field/fieldlistedit.cpp
    file/basicfileview.cpp
    file/clipboard.cpp
    file/filedelegate.cpp
    file/fileview.cpp
    file/partwidget.cpp
    file/findduplicatesui.cpp
    file/sortfilterfilemodel.cpp
    widgets/filesettingswidget.cpp
    widgets/filterbar.cpp
    widgets/hidingtabwidget.cpp
    widgets/menulineedit.cpp
    widgets/radiobuttontreeview.cpp
    widgets/rangewidget.cpp
    widgets/starrating.cpp
    config/entrylayout.cpp
    preferences/kbibtexpreferencesdialog.cpp
    preferences/settingsabstractwidget.cpp
    preferences/settingscolorlabelwidget.cpp
    preferences/settingsfileexporterpdfpswidget.cpp
    preferences/settingsfileexporterwidget.cpp
    preferences/settingsgeneralwidget.cpp
    preferences/settingsglobalkeywordswidget.cpp
    preferences/settingsidsuggestionswidget.cpp
    preferences/settingsidsuggestionseditor.cpp
    preferences/settingsuserinterfacewidget.cpp
    guihelper.cpp
    italictextitemmodel.cpp
    valuelistmodel.cpp
)

ecm_qt_declare_logging_category(kbibtexgui_SRCS
    HEADER logging_gui.h
    IDENTIFIER LOG_KBIBTEX_GUI
    CATEGORY_NAME kbibtex.gui
)

if(UNITY_BUILD)
    enable_unity_build(kbibtexgui kbibtexgui_SRCS)
endif(UNITY_BUILD)

add_library(kbibtexgui
    SHARED
    ${kbibtexgui_SRCS}
)
generate_export_header(kbibtexgui)
add_library(KBibTeX::GUI ALIAS kbibtexgui)

set_target_properties(kbibtexgui
    PROPERTIES
    EXPORT_NAME "kbibtexgui"
    VERSION ${KBIBTEX_RELEASE_VERSION}
    SOVERSION ${KBIBTEX_SOVERSION}
)

target_include_directories(kbibtexgui
    INTERFACE
        $<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR}/KBibTeX/gui>
)

target_link_libraries(kbibtexgui
    PUBLIC
        Qt5::Core
        Qt5::Widgets
    PRIVATE
        Poppler::Qt5
        Qt5::Gui
        Qt5::Concurrent
        Qt5::XmlPatterns
        KF5::ConfigCore
        KF5::I18n
        KF5::IconThemes
        KF5::WidgetsAddons
        KF5::KIOCore
        KF5::KIOFileWidgets
        KF5::Parts
        KF5::TextEditor
        KBibTeX::Config
        KBibTeX::Data
        KBibTeX::Global
        KBibTeX::IO
        KBibTeX::Networking
        KBibTeX::Processing
)

install(
    TARGETS kbibtexgui
    EXPORT kbibtexgui-targets
    LIBRARY NAMELINK_SKIP
    ${KDE_INSTALL_TARGETS_DEFAULT_ARGS}
)

set_target_properties(kbibtexgui PROPERTIES
    EXPORT_NAME "GUI"
)

ecm_generate_headers(kbibtexgui_HEADERS
    HEADER_NAMES
        element/AssociatedFilesUI
        element/ElementEditor
        element/ElementWidgets
        element/FindPDFUI
        field/ColorLabelWidget
        field/FieldInput
        field/FieldLineEdit
        field/FieldListEdit
        file/BasicFileView
        file/Clipboard
        file/FileDelegate
        file/FileView
        file/FindDuplicatesUI
        file/PartWidget
        file/SortFilterFileModel
        widgets/FileSettingsWidget
        widgets/FilterBar
        widgets/HidingTabWidget
        widgets/MenuLineEdit
        widgets/RadioButtonTreeView
        widgets/RangeWidget
        widgets/StarRating
        config/EntryLayout
        preferences/KBibTeXPreferencesDialog
        preferences/SettingsAbstractWidget
        preferences/SettingsColorLabelWidget
        preferences/SettingsFileExporterPDFPSWidget
        preferences/SettingsFileExporterWidget
        preferences/SettingsGeneralWidget
        preferences/SettingsGlobalKeywordsWidget
        preferences/SettingsIdSuggestionsEditor
        preferences/SettingsIdSuggestionsWidget
        preferences/SettingsUserInterfaceWidget
        ItalicTextItemModel
        ValueListModel
        GUIHelper
    REQUIRED_HEADERS kbibtexgui_HEADERS
)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/kbibtexgui_export.h
    ${kbibtexgui_HEADERS}
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/KBibTeX/gui
    COMPONENT Devel
)

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXGUI-configVersion.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY ExactVersion
)

configure_package_config_file(${CMAKE_CURRENT_LIST_DIR}/cmake/KBibTeXGUI-config.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXGUI-config.cmake
    INSTALL_DESTINATION ${KDE_INSTALL_LIBDIR}/cmake/KBibTeX
)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXGUI-config.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXGUI-configVersion.cmake
    DESTINATION ${KDE_INSTALL_LIBDIR}/cmake/KBibTeX
)

=== src/program/CMakeLists.txt ===
set(
    kbibtexprogram_SRCS
    program.cpp
    mainwindow.cpp
    documentlist.cpp
    mdiwidget.cpp
    docklets/statistics.cpp
    docklets/referencepreview.cpp
    docklets/documentpreview.cpp
    docklets/valuelist.cpp
    docklets/searchform.cpp
    docklets/searchresults.cpp
    docklets/elementform.cpp
    docklets/filesettings.cpp
    docklets/zoterobrowser.cpp
    openfileinfo.cpp
)

ecm_qt_declare_logging_category(kbibtexprogram_SRCS
    HEADER logging_program.h
    IDENTIFIER LOG_KBIBTEX_PROGRAM
    CATEGORY_NAME kbibtex.program
)

if(UNITY_BUILD AND NOT WIN32) # FIXME: Unity build of programs breaks on Windows
    enable_unity_build(kbibtex kbibtexprogram_SRCS)
endif(UNITY_BUILD AND NOT WIN32)


ecm_add_app_icon(kbibtexprogram_SRCS
    ICONS
    ${CMAKE_SOURCE_DIR}/icons/16-apps-kbibtex.png
    ${CMAKE_SOURCE_DIR}/icons/22-apps-kbibtex.png
    ${CMAKE_SOURCE_DIR}/icons/32-apps-kbibtex.png
    ${CMAKE_SOURCE_DIR}/icons/48-apps-kbibtex.png
    ${CMAKE_SOURCE_DIR}/icons/64-apps-kbibtex.png
    ${CMAKE_SOURCE_DIR}/icons/128-apps-kbibtex.png
)

add_executable(kbibtex
    ${kbibtexprogram_SRCS}
)

add_dependencies(kbibtex
    generate-kbibtex-git-info
)

target_include_directories(kbibtex
    PRIVATE
        ${CMAKE_BINARY_DIR}
)

target_link_libraries(kbibtex
    PRIVATE
        Qt5::Core
        KF5::CoreAddons
        KF5::Crash
        KF5::I18n
        KF5::IconThemes
        KF5::KIOCore
        KF5::KIOFileWidgets
        KF5::Parts
        KF5::Wallet
        KBibTeX::Global
        KBibTeX::GUI
        KBibTeX::IO
        KBibTeX::Networking
        KBibTeX::Processing
)

if(Qt5WebEngineWidgets_FOUND)
    message(STATUS "Using QtWebEngine to render complex HTML content")
    # Once CMake 3.12.x is minimum requirement, use 'add_compile_definitions'
    target_link_libraries(kbibtex
        PRIVATE
            Qt5::WebEngineWidgets
    )
else()
    if(Qt5WebKitWidgets_FOUND)
        message(STATUS "Using QtWebKit to render complex HTML content")
        # Once CMake 3.12.x is minimum requirement, use 'add_compile_definitions'
        add_definitions(
            -DHAVE_WEBKITWIDGETS
        )
        target_link_libraries(kbibtex
            PRIVATE
                Qt5::WebKitWidgets
         )
    else()
        message(STATUS "If available, using a KPart to render complex HTML content")
    endif()
endif()


install(
    TARGETS
    kbibtex
    ${KDE_INSTALL_TARGETS_DEFAULT_ARGS}
)

install(
    PROGRAMS
    org.kde.kbibtex.desktop
    DESTINATION
    ${KDE_INSTALL_APPDIR}
)
install(
    FILES
    kbibtexui.rc
    DESTINATION
    ${KDE_INSTALL_KXMLGUI5DIR}/kbibtex
)
install(
    FILES
    org.kde.kbibtex.appdata.xml
    DESTINATION
    ${KDE_INSTALL_METAINFODIR}
)

ecm_install_icons(
    ICONS
    ${CMAKE_SOURCE_DIR}/icons/16-apps-kbibtex.png
    ${CMAKE_SOURCE_DIR}/icons/22-apps-kbibtex.png
    ${CMAKE_SOURCE_DIR}/icons/32-apps-kbibtex.png
    ${CMAKE_SOURCE_DIR}/icons/48-apps-kbibtex.png
    ${CMAKE_SOURCE_DIR}/icons/64-apps-kbibtex.png
    ${CMAKE_SOURCE_DIR}/icons/128-apps-kbibtex.png
    DESTINATION ${KDE_INSTALL_ICONDIR}
)

=== debian/changelog ===
kbibtex (0.10.0-0xneon+22.04+jammy+release+build8) jammy; urgency=medium

  * Automatic CI Build

 -- Neon CI <neon@kde.org>  Tue, 16 May 2023 05:04:24 +0000

kbibtex (0.10.0-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sun, 19 Mar 2023 11:26:07 +0000

kbibtex (0.9.3.2-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sun, 05 Mar 2023 11:26:07 +0000

kbibtex (0.9.3.1-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sun, 22 Jan 2023 11:26:07 +0000

kbibtex (0.9.2-0neon) focal; urgency=medium

  * New release

 -- Harald Sitter <sitter@kde.org>  Tue, 22 Sep 2020 15:00:26 +0200

kbibtex (0.9-0neon) focal; urgency=medium

  * KF5 package

 -- Jonathan Riddell <jr@jriddell.org>  Thu, 15 Jun 2017 16:31:23 +0100

=== debian/control ===
Source: kbibtex
Section: kde
Priority: optional
Uploaders: Bastien Roucariès <roucaries.bastien+debian@gmail.com>
Build-Depends: cmake (>= 2.6~),
               debhelper (>= 7.0.50~),
               extra-cmake-modules,
               libkf5completion-dev,
               libkf5coreaddons-dev,
               libkf5crash-dev,
               libkf5doctools-dev,
               libkf5i18n-dev,
               libkf5iconthemes-dev,
               libkf5itemviews-dev,
               libkf5kio-dev,
               libkf5parts-dev,
               libkf5service-dev,
               libkf5syntaxhighlighting-dev,
               libkf5texteditor-dev,
               libkf5wallet-dev,
               libkf5xmlgui-dev,
               libpoppler-qt5-dev,
               libqca-qt5-2-dev,
               libqt5networkauth5-dev,
               libqt5webkit5-dev,
               libqt5xmlpatterns5-dev,
               libxslt1-dev,
               qtbase5-dev,
               qtwebengine5-dev
Standards-Version: 3.9.2
Homepage: http://www.unix-ag.uni-kl.de/~fischer/kbibtex
XS-DM-Upload-Allowed: yes
Vcs-Git: https://invent.kde.org/neon/forks/kbibtex.git
Vcs-Browser: https://invent.kde.org/neon/forks/kbibtex
Maintainer: Neon CI <neon@kde.org>

Package: kbibtex
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: bibtex2html, latex2rtf, texlive-latex-base | tetex-extra
Recommends: texlive-bibtex-extra
Description: BibTeX editor for KDE
 An application to manage bibliography databases in the BibTeX format. KBibTeX
 can be used as a standalone program, but can also be embedded into other KDE
 applications (e.g. as bibliography editor into Kile).
 .
 KBibTeX can query online resources (e.g. Google scholar) via customizable
 search URLs. It is also able to import complete datasets from NCBI Pubmed.
 It also supports tagging references with keywords and manages references to
 local files.
 .
 BibTeX files can be exported into HTML, XML, PDF, PS and RTF format using a
 number of citation styles.

=== debian/rules ===
#!/usr/bin/make -f

# one ring to rule them all ...
%:
	dh $@

override_dh_auto_test:
	#Disable dh_auto_test at build time
	:

=== debian/tests/control ===
Tests: testsuite
Depends: build-essential, dbus-x11, kinit, xauth, xvfb, @, @builddeps@
Restrictions: build-needed

=== debian/watch ===
version=4
http://download.kde.org/stable/KBibTeX/([\d\.]+)/kbibtex-([\d\.]+).tar.xz

## kbibtex 0.10.0+p24.04+vstable+git20250921.0627

=== debian/changelog ===
kbibtex (0.10.0+p24.04+vstable+git20250921.0627-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 21 Sep 2025 06:27:33 +0000

kbibtex (0.10.0-2) unstable; urgency=medium

  * Drop the spurious RUNPATH to /usr/ in libraries and executables
    - add the chrpath build dependency
  * Update copyright.
  * Update lintian overrides.
  * Switch the transitional pkg-config build dependency to pkgconf.
  * Bump Standards-Version to 4.7.0, no changes required.

 -- Pino Toscano <pino@debian.org>  Wed, 01 May 2024 09:47:53 +0200

kbibtex (0.10.0-1) unstable; urgency=medium

  * New upstream release.
  * Use execute_after_dh_auto_install to avoid invoking dh_auto_install
    manually.
  * Drop the breaks/replaces for versions older than Debian Buster.
  * Switch watch file to the stable releases, now that 0.10.0 is released.
  * Update standards version to 4.6.2, no changes needed.
  * Update the patches:
    - 0001-Fix-crash-with-newer-Qt-versions.patch: drop, backported from
      upstream
    - 0001-Fixing-crash-when-opening-.bib-file.patch: drop, backported from
      upstream
  * Drop the qtwebengine5-dev on mipsel, as that architecture was recently
    dropped.
  * Remove an obsolete maintscript entry.

 -- Pino Toscano <pino@debian.org>  Mon, 04 Sep 2023 07:12:17 +0200

## kbibtex 0.10.0+p24.04+vstable+git20250927.0404

=== debian/changelog ===
kbibtex (0.10.0+p24.04+vstable+git20250927.0404-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sat, 27 Sep 2025 04:04:32 +0000

## kbibtex 0.10.0+p24.04+vstable+git20251020.0536

=== src/data/CMakeLists.txt ===
# KBibTeXData library

set(
    kbibtexdata_SRCS
    comment.cpp
    element.cpp
    entry.cpp
    file.cpp
    macro.cpp
    preamble.cpp
    value.cpp
    models/filemodel.cpp
)

ecm_qt_declare_logging_category(kbibtexdata_SRCS
    HEADER logging_data.h
    IDENTIFIER LOG_KBIBTEX_DATA
    CATEGORY_NAME kbibtex.data
)

if(UNITY_BUILD)
    enable_unity_build(kbibtexdata kbibtexdata_SRCS)
endif(UNITY_BUILD)

add_library(kbibtexdata
    SHARED
    ${kbibtexdata_SRCS}
)
generate_export_header(kbibtexdata)
add_library(KBibTeX::Data ALIAS kbibtexdata)

set_target_properties(
    kbibtexdata
    PROPERTIES
    EXPORT_NAME "kbibtexdata"
    VERSION ${KBIBTEX_RELEASE_VERSION}
    SOVERSION ${KBIBTEX_SOVERSION}
)

target_include_directories(kbibtexdata
    INTERFACE
        $<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR}/KBibTeX/data>
)

target_link_libraries(kbibtexdata
    PUBLIC
        Qt5::Core
        KBibTeX::Config
    PRIVATE
        KF5::ConfigCore
        KF5::I18n
        KBibTeX::Global
)

install(
    TARGETS kbibtexdata
    EXPORT kbibtexdata-targets
    LIBRARY NAMELINK_SKIP
    ${KDE_INSTALL_TARGETS_DEFAULT_ARGS}
)

set_target_properties(kbibtexdata PROPERTIES
    EXPORT_NAME "Data"
)

ecm_generate_headers(kbibtexdata_HEADERS
    HEADER_NAMES
        Comment
        Element
        Entry
        File
        Macro
        Preamble
        Value
        models/FileModel
    REQUIRED_HEADERS kbibtexdata_HEADERS
)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/kbibtexdata_export.h
    ${kbibtexdata_HEADERS}
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/KBibTeX/data
    COMPONENT Devel
)

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXData-configVersion.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY ExactVersion
)

configure_package_config_file(${CMAKE_CURRENT_LIST_DIR}/cmake/KBibTeXData-config.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXData-config.cmake
    INSTALL_DESTINATION ${KDE_INSTALL_LIBDIR}/cmake/KBibTeX
)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXData-config.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/KBibTeXData-configVersion.cmake
    DESTINATION ${KDE_INSTALL_LIBDIR}/cmake/KBibTeX
)
